(provide 'exceptions)
(require 'stack)

(define *exception-handler-stack* (stack:new))

(define *empty-continuation*
  (lambda foo (sys$$error "Tried to resume empty continuation.")))
(define (default-exception-handler foo k)
  (sys$$error "Uncaught exception " foo))

(define (exception:throw foo)
  (call/cc
   (lambda (k)
     (exception:next-handler foo k))))

(define (exception:next-handler foo)
  (if (stack:empty *exception-handler-stack*)
      (default-exception-handler foo)
      (exception::handle (stack:pop! *exception-handler-stack*) foo k)))

(define (exception::handle handler foo k)
  (handler foo k))

(define (exception:catch handler thunk)
  (dynamic-wind
   (lambda () (stack:push! *exception-handler-stack* handler))
   thunk
   (lambda () (stack:pop! *exception-handler-stack* handler))))


(if #t (begin
(exception:catch
 (lambda (foo k)
   (display foo)
   (newline)
   (k))
 (lambda ()
   (display 1)
   (exception:throw 'bar)
   (display 2)
   (newline)))
(exception:throw 'baz)
))
