; LIFO stacks

(provide 'stack)
(require 'lib)
(require 'ref)
(require 'types)

(define stack$$mark (types:make-tag 'stack))
(define (stack? o)
   (and (pair? o) (eq? (car o) stack$$mark)))
(types:register 'stack stack?)

(define (stack:new)
   (cons stack$$mark (ref:new '())))

(define (stack:empty? s)
   ($assert stack? s)
   (let ((r (cdr s)))
   (null? (ref:get r))))

(define (stack:push! s x)
   ($assert stack? s)
   (let ((r (cdr s)))
   (ref:set! r (cons x (ref:get r)))))

(define (stack:peek s)
   ($assert stack? s)
   (let ((r (cdr s)))
   (car (ref:get r))))

(define (stack:pop! s)
   ($assert stack? s)
   (let*
      ((r (cdr s))
       (o (ref:get r))
       (a (car o))
       (d (cdr o)))
      (ref:set! r d)
      a))

(define (stack->list s)
   ($assert stack? s)
   (ref:get (cdr s)))

(if #f (begin
(define test (stack:new))
(write (stack:empty? test))
(write (stack:push! test 1))
(write (stack:push! test 2))
(write (stack:push! test 3))
(write (stack:pop! test))
(write (stack->list test))))
